unit scrn;

interface

uses
  Windows
  //, Messages
  , SysUtils
  , Classes
  , Graphics
  //, Controls
  , Forms
  //, Dialogs
  ,ExtCtrls
  //, StdCtrls
  ;

type
  TSaverScreen = class(TForm)
    Timer1: TTimer;
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  SaverScreen: TSaverScreen;

  Kontrast_Trackbar,Kontrastmaximum_Trackbar,Kontrastmittelwert,
  Helligkeit_Trackbar,Helligkeitsmaximum_Trackbar,Helligkeitsmittelwert,
  Saettigung_Trackbar,Saettigungsmaximum_Trackbar,
  Farbmischung,Pixelabstand,Pixelgroesse:integer;
  Pixelform_Quadrat:boolean;

  Kontrastverhaeltnis,Kontrastinvertverhaeltnis,
  Helligkeitsverhaeltnis,Helligkeitsinvertverhaeltnis,
  Saettigungsinvertverhaeltnis:single;

  Saettigung,Farbwert,x_reduziert,y_reduziert:word;//Farbwert global, damit er nicht immer wieder eingenullt werden "mu" - angeblich nicht initialisiert

procedure Ausgabe(Ausgabe_canvas:TCanvas;x,y:word);

implementation

{$R *.DFM}

const
  HLSMAX=240;
  RGBMAX=255;
  HLSUndefined=HLSMAX*2/3;

var //beendbar_ueber_Eingabe:boolean=false;
abbruch:boolean=false;
fLastX:Integer=0;
fLastY:Integer=0;

procedure Ausgabe(Ausgabe_canvas:TCanvas;x,y:word);
var Rot,Farbe:TColor;
Zufallszahl:single;
{Farbwert,}Helligkeit:word;//bei lokalem Farbwert wird fehlende Initialisierung bemngelt; knnte man lassen, aber bei jedem Funktionsaufruf diesen einzunullen ist auch nicht sinnvol

  function ColorHLSToRGB(Hue,Luminance,Saturation:word):longint;//TColorRef;

    function HueToRGB(Lum,Sat,Hue:single):Integer;
    var  ResultEx:single;
    begin
    if hue<0 then hue:=hue+HLSMAX;
    if hue>HLSMAX then hue:=hue-HLSMAX;
    if hue<HLSMAX/6
    then ResultEx:=Lum+6*((Sat-Lum)*hue+HLSMAX/12)/HLSMAX //Multiplikation mit 6 anstatt Division durch (HLSMAX/6)
    else if hue<HLSMAX/2
         then ResultEx:=Sat
         else if hue<HLSMAX*2/3
              then ResultEx:=Lum+6*((Sat-Lum)*(HLSMAX*2/3-hue)+HLSMAX/12)/HLSMAX //Multiplikation mit 6 anstatt Division durch (HLSMAX/6)
              else ResultEx:=Lum;
    Result:=Round(ResultEx)
    end;

    function RoundColor(Value:single):Integer;
    begin
    if Value>255 then Result:=255 else Result:=Round(Value)
    end;

  var R,G,B,Magic1,Magic2:single;
  begin
  if Saturation=0 then
    begin            { achromatic case }
    R:=Luminance*RGBMAX/HLSMAX;
    G:=R;
    B:=R;
    if Hue<>HLSUndefined then { ERROR }
    end
  else
    begin
    if Luminance<=HLSMAX/2
    then Magic2:=(Luminance*(HLSMAX+Saturation)+HLSMAX/2)/HLSMAX
    else Magic2:=Luminance+Saturation-(Luminance*Saturation+HLSMAX/2)/HLSMAX;
    Magic1:=2*Luminance-Magic2;
    R:=(HueToRGB(Magic1,Magic2,Hue+HLSMAX/3)*RGBMAX+HLSMAX/2)/HLSMAX;
    G:=(HueToRGB(Magic1,Magic2,Hue)*RGBMAX+HLSMAX/2)/HLSMAX;
    B:=(HueToRGB(Magic1,Magic2,Hue-HLSMAX/3)*RGBMAX+HLSMAX/2)/HLSMAX;
    end;
  Result:=RGB(RoundColor(R),RoundColor(G),RoundColor(B))
  end;

  procedure Grosspixel(a:TColor);
  var x,y:word;
  begin
  x:=Pixelabstand*random(x_reduziert);
  y:=Pixelabstand*random(y_reduziert);
  Ausgabe_Canvas.Pen.Color:=a;
  if Pixelabstand>2 then Ausgabe_Canvas.Brush.Color:=a;//Abfrage nicht ntig, aber vorteilhaft, wenn Rechtecke nur 2 Pixel Seitenlnge haben -> kein Inhalt
  if Pixelform_Quadrat
  then Ausgabe_Canvas.Rectangle(x,y,x+Pixelgroesse,y+Pixelgroesse)
  else Ausgabe_Canvas.Ellipse(x,y,x+Pixelgroesse,y+Pixelgroesse)
  end;

begin
rot:=random(256);//zunchst nur Rot, daraus werden die anderen Farben generiert

//Berechnung des Kontrastes
if Kontrast_Trackbar<Kontrastmittelwert then
    //rot:=round(rot*Trackbarverhaeltnis)+(256-round(256*Trackbarinvertverhaeltnis)) div 2
    //rot:=128+round(Farbe*Trackbarverhaeltnis)-round(128*Trackbarinvertverhaeltnis)
    rot:=128+round((rot-128)*Kontrastverhaeltnis)
  else
    if Kontrast_Trackbar>Kontrastmittelwert then
      begin
      rot:=round(random+rot*Kontrastinvertverhaeltnis);
      if rot>round(256*Kontrastinvertverhaeltnis) div 2
      then rot:=256-(rot-round(256*Kontrastinvertverhaeltnis) div 2)
      end;

//Berechnung der Helligkeit
if Helligkeit_Trackbar<Helligkeitsmittelwert
then rot:=round(rot*Helligkeitsverhaeltnis)
else if Helligkeit_Trackbar>Helligkeitsmittelwert then rot:=255-round(({255-}rot)*Helligkeitsverhaeltnis);

//Berechnung der Sttigung
if Saettigung_TrackBar=0 then
  //Schwar-Wei(-Grau)-Ausgabe, entweder als Pixel oder als Rechteck
  if Pixelabstand=1 then Ausgabe_Canvas.Pixels[random(x),random(y)]:=rot+rot shl 8 + rot shl 16//zum Wei, Grau oder Schwarz mischen
  else Grosspixel(rot+rot shl 8 + rot shl 16)
else
  begin
  Helligkeit:=(120*rot) div 255;
  Helligkeit:=Helligkeit+round(Saettigungsinvertverhaeltnis*Helligkeit);
  if Farbmischung=0 then //nur rot, grn oder blau
    begin
      case random(3) of
      0:Farbwert:=0;
      1:Farbwert:=80;//grn
      2:Farbwert:=160//blau
      end
    end
  else
    begin//Mischfarben generieren
    //Farbwert:=random(241)
    zufallszahl:=random;
      case random(3) of
      0:Farbwert:=round(80*Zufallszahl); //zwischen rot und grn
      1:Farbwert:=80+round(80*Zufallszahl);//zwischen rot und blau
      2:Farbwert:=160+round(80*Zufallszahl)//zwischen grn und blau
      end
    end;

  {Jetzt knnte man die Helligkeit aus der Trackbar 2 extrahieren, doch dabei wird der Kontrast unterschlagen.
  Dehalb werden die Helligkeit und der Kontrast aus der bisherigen - noch vollgesttigten - Pixelfarbe extrahiert.}
  Farbe:=ColorHLSToRGB(Farbwert,Helligkeit,Saettigung);

  //Farbausgabe, und zwar entweder als Pixel oder als Rechteck
  if Pixelabstand=1
  then Ausgabe_Canvas.Pixels[random(x),random(y)]:=Farbe//zum Wei, Grau oder Schwarz mischen
  else Grosspixel(Farbe)
  end

//Canvas.Pixels[random(x),random(y)]:=rot//random($FFFFFF+1)
end;

procedure TSaverScreen.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
if copy(upperCase(paramstr(1)),1,2)<>'/C' then
  begin
  if (fLastX > 0) and (fLastY > 0) then // erstes Mal ausschlieen
    if (abs(fLastX-x)>0) or (abs(fLastY-y)>0) then  //Close;
      abbruch:=true;
  fLastX:=x;
  fLastY:=y
  end
end;

procedure TSaverScreen.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
abbruch:=true
end;

procedure TSaverScreen.Timer1Timer(Sender: TObject);
begin
Timer1.Enabled:=false;
x_reduziert:=succ({Screen.}Width div Pixelabstand);//succ({Screen}Form2.Width div SpinEdit1.Value);
y_reduziert:=succ({Screen.}Height div Pixelabstand);//succ({Screen}Form2.Height div SpinEdit1.Value);
while not abbruch do
  begin
  Application.ProcessMessages;
  Ausgabe(Canvas,{Screen.}Width,{Screen.}Height)
  end;
SaverScreen.close//Application.Terminate
end;

procedure TSaverScreen.FormCreate(Sender: TObject);
begin
Cursor:=-1;
//die folgenden Befehle sind bei Verwendung von Delphi 2 ntig, nicht jedoch mit Delphi 3
{$IFDEF VER90}
Left:=0;
Top:=0;
Width:=screen.width;
Height:=screen.height
{$ENDIF}
end;

end.
